/*
Postman's Sort (R) Version 1.0
Copyright (c) Robert Ramey 1991. All Rights Reserved
*/

#include "record.h"

/*********************************************************************
data structure and allocation variables for sublist headers
**********************************************************************/
/* structure for each list of partially sorted records */
typedef struct {
	RECORD *memory;		/* address of portion in memory */
	FILE_SIZE disk;		/* or when its in the overflow working file */
	FILE_SIZE size;		/* number of bytes in this sublist */
	unsigned int count;	/* number of records in memory */
	unsigned long pcount;/* count of records written to work file */
} SUBLIST;

extern STACK *s_stack;
extern int rb_size, sb_size;

void
sublist_init();
RECORD *
sublist_input(SUBLIST *);
void
sublist_output(SUBLIST *, BOOLEAN);
SUBLIST *
sublist_allocate(unsigned int);
void
sublist_empty(int, SUBLIST *, int);
